/*
Copyright 2020 VMware, Inc.
SPDX-License-Identifier: Apache-2.0
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "github.com/suzerain-io/pinniped/generated/1.17/apis/crdpinniped/v1alpha1"
	scheme "github.com/suzerain-io/pinniped/generated/1.17/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// PinnipedDiscoveryInfosGetter has a method to return a PinnipedDiscoveryInfoInterface.
// A group's client should implement this interface.
type PinnipedDiscoveryInfosGetter interface {
	PinnipedDiscoveryInfos(namespace string) PinnipedDiscoveryInfoInterface
}

// PinnipedDiscoveryInfoInterface has methods to work with PinnipedDiscoveryInfo resources.
type PinnipedDiscoveryInfoInterface interface {
	Create(*v1alpha1.PinnipedDiscoveryInfo) (*v1alpha1.PinnipedDiscoveryInfo, error)
	Update(*v1alpha1.PinnipedDiscoveryInfo) (*v1alpha1.PinnipedDiscoveryInfo, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.PinnipedDiscoveryInfo, error)
	List(opts v1.ListOptions) (*v1alpha1.PinnipedDiscoveryInfoList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.PinnipedDiscoveryInfo, err error)
	PinnipedDiscoveryInfoExpansion
}

// pinnipedDiscoveryInfos implements PinnipedDiscoveryInfoInterface
type pinnipedDiscoveryInfos struct {
	client rest.Interface
	ns     string
}

// newPinnipedDiscoveryInfos returns a PinnipedDiscoveryInfos
func newPinnipedDiscoveryInfos(c *CrdV1alpha1Client, namespace string) *pinnipedDiscoveryInfos {
	return &pinnipedDiscoveryInfos{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the pinnipedDiscoveryInfo, and returns the corresponding pinnipedDiscoveryInfo object, and an error if there is any.
func (c *pinnipedDiscoveryInfos) Get(name string, options v1.GetOptions) (result *v1alpha1.PinnipedDiscoveryInfo, err error) {
	result = &v1alpha1.PinnipedDiscoveryInfo{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of PinnipedDiscoveryInfos that match those selectors.
func (c *pinnipedDiscoveryInfos) List(opts v1.ListOptions) (result *v1alpha1.PinnipedDiscoveryInfoList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.PinnipedDiscoveryInfoList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested pinnipedDiscoveryInfos.
func (c *pinnipedDiscoveryInfos) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a pinnipedDiscoveryInfo and creates it.  Returns the server's representation of the pinnipedDiscoveryInfo, and an error, if there is any.
func (c *pinnipedDiscoveryInfos) Create(pinnipedDiscoveryInfo *v1alpha1.PinnipedDiscoveryInfo) (result *v1alpha1.PinnipedDiscoveryInfo, err error) {
	result = &v1alpha1.PinnipedDiscoveryInfo{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		Body(pinnipedDiscoveryInfo).
		Do().
		Into(result)
	return
}

// Update takes the representation of a pinnipedDiscoveryInfo and updates it. Returns the server's representation of the pinnipedDiscoveryInfo, and an error, if there is any.
func (c *pinnipedDiscoveryInfos) Update(pinnipedDiscoveryInfo *v1alpha1.PinnipedDiscoveryInfo) (result *v1alpha1.PinnipedDiscoveryInfo, err error) {
	result = &v1alpha1.PinnipedDiscoveryInfo{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		Name(pinnipedDiscoveryInfo.Name).
		Body(pinnipedDiscoveryInfo).
		Do().
		Into(result)
	return
}

// Delete takes name of the pinnipedDiscoveryInfo and deletes it. Returns an error if one occurs.
func (c *pinnipedDiscoveryInfos) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *pinnipedDiscoveryInfos) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched pinnipedDiscoveryInfo.
func (c *pinnipedDiscoveryInfos) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.PinnipedDiscoveryInfo, err error) {
	result = &v1alpha1.PinnipedDiscoveryInfo{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("pinnipeddiscoveryinfos").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
